Bug 18837 - Add an unmediated Interlibrary Loans workflow
Summary: Add an unmediated Interlibrary Loans workflow
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: ILL (show other bugs)
Version: unspecified
Hardware: All All
: P5 - low enhancement (vote)
Target Milestone: ---
Assignee: Andrew Isherwood
QA Contact: Josef Moravec
URL:
Whiteboard:
Keywords:
Depends on: 21063
Blocks: 20563
  Show dependency treegraph
 
Reported: 2017-06-21 14:44 UTC by Alex Sassmannshausen
Modified: 2019-03-19 10:45 UTC (History)
8 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Bot Control: ---
When did the bot last check this:
Who signed the patch off:
Text to go in the release notes:
Version(s) released in:


Attachments
Add ILL Unmediated syspref stuff. (3.13 KB, patch)
2017-08-30 15:43 UTC, Alex Sassmannshausen
Details | Diff | Splinter Review
Introduce delegation to backends for unmediated workflows. (2.48 KB, patch)
2017-08-30 15:43 UTC, Alex Sassmannshausen
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.31 KB, patch)
2018-04-26 11:09 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.00 KB, patch)
2018-04-26 11:09 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.45 KB, patch)
2018-09-27 16:45 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.16 KB, patch)
2018-09-27 16:45 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.47 KB, patch)
2018-11-09 11:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.16 KB, patch)
2018-11-09 11:45 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.47 KB, patch)
2018-11-19 14:36 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.16 KB, patch)
2018-11-19 14:36 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.71 KB, patch)
2019-03-06 15:15 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.16 KB, patch)
2019-03-06 15:15 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.45 KB, patch)
2019-03-07 09:09 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.16 KB, patch)
2019-03-07 09:09 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: (QA follow-up) Update system preference desciprition (1.27 KB, patch)
2019-03-07 11:27 UTC, Josef Moravec
Details | Diff | Splinter Review
Bug 18837: (follow-up) Add additional tests (3.48 KB, patch)
2019-03-08 11:30 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.52 KB, patch)
2019-03-08 11:38 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.16 KB, patch)
2019-03-08 11:38 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: (QA follow-up) Update system preference desciprition (1.07 KB, patch)
2019-03-08 11:38 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: (follow-up) Add additional tests (3.48 KB, patch)
2019-03-08 11:38 UTC, Andrew Isherwood
Details | Diff | Splinter Review
Bug 18837: Add ILL Unmediated syspref stuff (3.58 KB, patch)
2019-03-11 08:22 UTC, Josef Moravec
Details | Diff | Splinter Review
Bug 18837: Introduce delegation to backends for unmediated workflows (2.21 KB, patch)
2019-03-11 08:22 UTC, Josef Moravec
Details | Diff | Splinter Review
Bug 18837: (QA follow-up) Update system preference desciprition (1.12 KB, patch)
2019-03-11 08:23 UTC, Josef Moravec
Details | Diff | Splinter Review
Bug 18837: (follow-up) Add additional tests (3.53 KB, patch)
2019-03-11 08:23 UTC, Josef Moravec
Details | Diff | Splinter Review
Bug 18837: (QA follow-up) Fix order of sysprefa.sql (1.52 KB, patch)
2019-03-11 08:23 UTC, Josef Moravec
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Alex Sassmannshausen 2017-06-21 14:44:04 UTC
Some libraries may wish to allow their patrons to place Interlibrary loan requests without those requests going through a formal moderation process.

The ILLModule cannot guarantee an unmediated workflow for every backend.

I propose the following approach:
- A system preference switching this functionality on & off.
- Use ILL module's generic capabilities functionality to allow execution of unmediated requests on a per backend basis, but falling back on the normal process for backends that don't support unmediated.

Alex
Comment 1 Alex Sassmannshausen 2017-08-30 15:43:29 UTC
Created attachment 66628 [details] [review]
Add ILL Unmediated syspref stuff.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
  Add `ILLModuleUnmediated` handling.
Comment 2 Alex Sassmannshausen 2017-08-30 15:43:32 UTC
Created attachment 66629 [details] [review]
Introduce delegation to backends for unmediated workflows.

* Koha/Illrequest.pm (backend_create): Add dispatch.
Comment 3 Andrew Isherwood 2018-04-26 11:09:10 UTC
Created attachment 74874 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.
Comment 4 Andrew Isherwood 2018-04-26 11:09:16 UTC
Created attachment 74875 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply
Comment 5 Katrin Fischer 2018-04-27 05:49:14 UTC
Hi Andrew, please always make sure to include a test plan.
Comment 6 Andrew Isherwood 2018-04-27 06:59:05 UTC
Hi Katrin

Thanks for the reminder. I'd not added test plans because these patches were simply direct replacements for Alex's, which had become impossible to apply. The work on this bug is incomplete so there's a good chance these patches will be obsoleted as I complete the work. I figured it was probably OK to not include test plans yet as no-one would be trying to test it as it's not yet in "Needs signoff", and won't be until the work is complete.

Hope that's OK.

Andrew
Comment 7 Katrin Fischer 2018-04-27 08:27:13 UTC
Ah sure, I missed ASSIGNED the status!
Comment 8 Andrew Isherwood 2018-05-09 13:49:30 UTC
To test:

- Apply patches
- Ensure ILL is enabled and you have at least one backend available that supports unmediated requests (currently only the BLDSS backend supports this)
- Enable "ILLModuleUnmediated" preference
- As an OPAC user, navigate to "Your summary" > "Your interlibrary loan requests"
- Select "Create a new request" > "BLDSS"
- Search for an item and create an interlibrary loan request
- Observe that in the "Your interlibrary loan requests" view, the request now has the status of "Requested" rather than the "New request" status that it would have in an mediated workflow.
Comment 9 Martin Renvoize 2018-09-27 16:45:10 UTC
Created attachment 79542 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 10 Martin Renvoize 2018-09-27 16:45:14 UTC
Created attachment 79543 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 11 Martin Renvoize 2018-09-27 16:46:30 UTC
Hertfordshire University have undertaken lots of testing upon this work and have been running it in production for some time now. 

They have asked me to sign it off on their behalf.. I have added their testing team to the patches signoff lines.

Thanks guys :)
Comment 12 Andrew Isherwood 2018-11-09 11:45:49 UTC
Created attachment 82158 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 13 Andrew Isherwood 2018-11-09 11:45:53 UTC
Created attachment 82159 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 14 Andrew Isherwood 2018-11-09 11:46:13 UTC
Rebased on top of current dependency tree
Comment 15 Andrew Isherwood 2018-11-19 14:36:28 UTC
Created attachment 82508 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 16 Andrew Isherwood 2018-11-19 14:36:33 UTC
Created attachment 82509 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 17 Josef Moravec 2019-03-05 17:01:58 UTC
Could you rebase please?
Comment 18 Andrew Isherwood 2019-03-06 15:15:09 UTC
Created attachment 86188 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 19 Andrew Isherwood 2019-03-06 15:15:12 UTC
Created attachment 86189 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 20 Andrew Isherwood 2019-03-06 16:02:18 UTC
To test:

- Apply patches
- Ensure ILL is enabled and you have at least one backend available that supports unmediated requests (currently only the BLDSS backend supports this)
- Enable "ILLModuleUnmediated" preference
- Ensure you have default delivery formats specified in your koha-conf.xml. These should be placed inside the <interlibrary_loans> block, an example (which specifies the loan should be a paper copy, of standard quality, delivered within 4 days) is below:

<default_formats>                                                                                                                                                     
    <format>4</format>                                                                                                                                                
    <speed>4</speed>                                                                                                                                                  
    <quality>1</quality>                                                                                                                                              
</default_formats>

- As an OPAC user, navigate to "Your summary" > "Your interlibrary loan requests"
- Select "Create a new request" > "BLDSS"
- Search for an item and create an interlibrary loan request
=> TEST: Observe that in the "Your interlibrary loan requests" view, the request now has the status of "Requested" rather than the "New request" status that it would have in an mediated workflow.
Comment 21 Josef Moravec 2019-03-07 08:50:26 UTC
When the library has missing some data it is shown like this:
https://screenshots.firefox.com/R4iMqp2SVyEkh8Qz/localhost

But when is missing country, it dies in BLDSS/Base.pm, (but request is still created with status "New") not sure if we could do something with this in Koha...

Also, you have ILLOpacbackends in sysprefs and yaml, but not in db update and also not used in code, so probably should be removed

When I have all address data OK, I got this message: "Invalid Request: At least one Item Of Interest level piece of metadata is required."
Is it possible to show which metadata is missing?
Comment 22 Andrew Isherwood 2019-03-07 09:09:52 UTC
Created attachment 86236 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 23 Andrew Isherwood 2019-03-07 09:09:56 UTC
Created attachment 86237 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 24 Andrew Isherwood 2019-03-07 09:12:39 UTC
(In reply to Josef Moravec from comment #21)
> When the library has missing some data it is shown like this:
> https://screenshots.firefox.com/R4iMqp2SVyEkh8Qz/localhost
> 
> But when is missing country, it dies in BLDSS/Base.pm, (but request is still
> created with status "New") not sure if we could do something with this in
> Koha...

Yes, I'll create a bug report on the BLDSS Github site so we can get it fixed.

> Also, you have ILLOpacbackends in sysprefs and yaml, but not in db update
> and also not used in code, so probably should be removed

Updated patches attached

> When I have all address data OK, I got this message: "Invalid Request: At
> least one Item Of Interest level piece of metadata is required."
> Is it possible to show which metadata is missing?

Sadly not, that error is coming back from the BLDSS service, it's not very helpful, I agree! :(
Comment 25 Josef Moravec 2019-03-07 09:21:29 UTC
(In reply to Andrew Isherwood from comment #24)
> (In reply to Josef Moravec from comment #21)
> > When the library has missing some data it is shown like this:
> > https://screenshots.firefox.com/R4iMqp2SVyEkh8Qz/localhost
> > 
> > But when is missing country, it dies in BLDSS/Base.pm, (but request is still
> > created with status "New") not sure if we could do something with this in
> > Koha...
> 
> Yes, I'll create a bug report on the BLDSS Github site so we can get it
> fixed.
> 
> > Also, you have ILLOpacbackends in sysprefs and yaml, but not in db update
> > and also not used in code, so probably should be removed
> 
> Updated patches attached
> 
> > When I have all address data OK, I got this message: "Invalid Request: At
> > least one Item Of Interest level piece of metadata is required."
> > Is it possible to show which metadata is missing?
> 
> Sadly not, that error is coming back from the BLDSS service, it's not very
> helpful, I agree! :(

Thanks for answers and quick rebase! I am continuing here...
Comment 26 Josef Moravec 2019-03-07 11:27:12 UTC
Created attachment 86238 [details] [review]
Bug 18837: (QA follow-up) Update system preference desciprition
Comment 27 Andrew Isherwood 2019-03-08 11:30:12 UTC
Created attachment 86371 [details] [review]
Bug 18837: (follow-up) Add additional tests

As requested by Josef on IRC, we now mock the unmediated_ill backend
method and ensure it is called when the ILLModuleUnmediated syspref is
enabled and ensure it is not called when the syspref is disabled
Comment 28 Andrew Isherwood 2019-03-08 11:38:02 UTC
Created attachment 86372 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 29 Andrew Isherwood 2019-03-08 11:38:05 UTC
Created attachment 86373 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>
Comment 30 Andrew Isherwood 2019-03-08 11:38:08 UTC
Created attachment 86374 [details] [review]
Bug 18837: (QA follow-up) Update system preference desciprition
Comment 31 Andrew Isherwood 2019-03-08 11:38:11 UTC
Created attachment 86375 [details] [review]
Bug 18837: (follow-up) Add additional tests

As requested by Josef on IRC, we now mock the unmediated_ill backend
method and ensure it is called when the ILLModuleUnmediated syspref is
enabled and ensure it is not called when the syspref is disabled
Comment 32 Josef Moravec 2019-03-11 08:22:54 UTC
Created attachment 86422 [details] [review]
Bug 18837: Add ILL Unmediated syspref stuff

This patch adds the syspref requirements for unmediated ILL requests. It
is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66628&action=diff
which had diverged sufficiently as to make it impossible to apply.

* installer/data/mysql/atomicupdate/illunmediated_tables.sql: New
  file.
* installer/data/mysql/sysprefs.sql: Add `ILLModuleUnmediated`.
* koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/admin.pref:
    Add `ILLModuleUnmediated` handling.

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 33 Josef Moravec 2019-03-11 08:22:57 UTC
Created attachment 86423 [details] [review]
Bug 18837: Introduce delegation to backends for unmediated workflows

This patch adds support to Illrequest.pm to allow delegation of
unmediated requests to happen in backends that support them.

It is a recreation of
https://bugs.koha-community.org/bugzilla3/attachment.cgi?id=66629&action=diff
which had diverged sufficiently as to make it impossible to apply

Signed-off-by: Stephen Graham <s.graham4@herts.ac.uk>
Signed-off-by: David Peacock <d.m.peacock@herts.ac.uk>
Signed-off-by: Jayne Maisey <j.maisey@herts.ac.uk>

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 34 Josef Moravec 2019-03-11 08:23:01 UTC
Created attachment 86424 [details] [review]
Bug 18837: (QA follow-up) Update system preference desciprition

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 35 Josef Moravec 2019-03-11 08:23:05 UTC
Created attachment 86425 [details] [review]
Bug 18837: (follow-up) Add additional tests

As requested by Josef on IRC, we now mock the unmediated_ill backend
method and ensure it is called when the ILLModuleUnmediated syspref is
enabled and ensure it is not called when the syspref is disabled

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 36 Josef Moravec 2019-03-11 08:23:09 UTC
Created attachment 86426 [details] [review]
Bug 18837: (QA follow-up) Fix order of sysprefa.sql

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 37 Nick Clemens 2019-03-15 19:56:40 UTC
Awesome work all!

Pushed to master for 19.05
Comment 38 Martin Renvoize 2019-03-19 10:45:39 UTC
Enhancement, will not be backported to 18.11.x series.